package pjv10;
import java.util.*;

public class SeznamCisel {
    /* seznam s odkazem na voln� prvek */
    Prvek prvni;
    Prvek volny;
    
    public SeznamCisel() {
        prvni = new Prvek();
        volny = prvni;
    }
    
    public void vlozNaZacatek(int x) {
        prvni = new Prvek(x, prvni);
    }
    
    public void vlozNaKonec(int x) {
        volny.hodn = x;
        volny.dalsi = new Prvek();
        volny = volny.dalsi;
    }
    
    
    public boolean jePrvkem1(int x) {
        
        Prvek pom = prvni;
        while (pom.hodn!=x&& pom!=volny) pom = pom.dalsi;
        return pom!=volny;
    }
    
    public boolean jePrvkem(int x) {
        volny.hodn = x;
        Prvek pom = prvni;
        while (pom.hodn!=x) pom = pom.dalsi;
        return pom!=volny;
    }

        public boolean neniPrvkem(int x) {
        volny.hodn = x;
        Prvek pom = prvni;
        while (pom.hodn!=x) pom = pom.dalsi;
        return pom==volny;
    }
    public void vypis() {
        Prvek pom = prvni;
        while (pom!=volny) {
            System.out.print(pom.hodn+" ");
            pom = pom.dalsi;
        }
        System.out.println();
    }
    
    /* seznam s odkazem na poslední prvek */
/*
  Prvek prvni;
  Prvek posledni;
 
  public SeznamCisel() {
    prvni = null;
    posledni = null;
  }
 
  public void vlozNaZacatek(int x) {
    prvni = new Prvek(x, prvni);
    if (posledni==null) posledni = prvni;
  }
 
  public void vlozNaKonec(int x) {
    Prvek pom = new Prvek(x, null);
    if (posledni==null) {
      posledni = pom;
      prvni = pom;
    } else {
      posledni.dalsi = pom;
      posledni = pom;
    }
  }
 
  public boolean jePrvkem(int x) {
    Prvek pom = prvni;
    while (pom!=null && pom.hodn!=x) pom = pom.dalsi;
    return pom!=null;
  }
 
  public void vypis() {
    Prvek pom = prvni;
    while (pom!=null) {
      System.out.print(pom.hodn+" ");
      pom = pom.dalsi;
    }
    System.out.println();
  }
 */
    
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        SeznamCisel obracena = new SeznamCisel();
        SeznamCisel ruzna = new SeznamCisel();
        
        SeznamCisel jednoduseK = new SeznamCisel();
        
        jednoduseK.vlozNaKonec(22);
        jednoduseK.vlozNaKonec(18);
        jednoduseK.vlozNaKonec(14);

        jednoduseK.vypis();
        
        SeznamCisel jednoduseZ = new SeznamCisel();
        
        jednoduseZ.vlozNaZacatek(22);
        jednoduseZ.vlozNaZacatek(18);
        jednoduseZ.vlozNaZacatek(14);
        jednoduseZ.vypis();
        System.out.println("   test " + jednoduseZ.jePrvkem1(22));
        System.out.println("zadejte řadu čísel zakončenou nulou");
        int x = sc.nextInt();
        
        while (x!=0) {
            obracena.vlozNaZacatek(x);
            if (ruzna.neniPrvkem(x))
                ruzna.vlozNaKonec(x);
            x = sc.nextInt();
        }
        System.out.println("čísla v opačném pořadí");
        obracena.vypis();
        System.out.println("seznam různých čísel");
        ruzna.vypis();
    }
    class Prvek {
        int hodn;
        Prvek dalsi;
        
        public Prvek() {
            hodn = 0; dalsi = null;
        }
        
        public Prvek(int h, Prvek d) {
            hodn = h; dalsi = d;
        }
        
        public int hodn() {
            return hodn;
        }
        
        public Prvek dalsi() {
            return dalsi;
        }
    }
}
